Option Strict Off
Option Explicit On
Friend Class clsUpdateOrder
	
	Public Function UpdateOrderStatus(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngOrderID As Integer, ByVal bytStatus As Byte, ByVal strStatusMsg As String, ByVal lngTransactID As Integer) As Short
		
		'Change status of order and line items (single transaction)
		Dim cnnUpdate As New ADODB.Connection
		Dim strUpdateConn As String
		Dim strSQLOrder As String
		Dim strSQLItems As String
		Dim lngReccnt As Integer
		
      'On Error Resume Next
		
		If CInt(Val(strStatusMsg)) <> lngOrderID Then
			'For synchronous execution, match is required
			UpdateOrderStatus = -4
			Exit Function
		End If
		
		'Remove the Reference value
		strStatusMsg = Mid(strStatusMsg, InStr(strStatusMsg, " ") + 1)
		
		strUpdateConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
		If lngTransactID = 0 Then
			strSQLOrder = "UPDATE Orders SET StatusID = " & bytStatus & ", LastStatusMessage = '" & CStr(strStatusMsg) & "', LastStatusUpdate = '" & CStr(Now) & "' WHERE OrderID = " & CStr(lngOrderID)
		Else
			strSQLOrder = "UPDATE Orders SET StatusID = " & bytStatus & ", LastStatusMessage = '" & CStr(strStatusMsg) & "', LastStatusUpdate = '" & CStr(Now) & "', " & "CCTransactionID = " & CStr(lngTransactID) & " WHERE OrderID = " & CStr(lngOrderID)
		End If
		strSQLItems = "UPDATE LineItems SET StatusID = " & bytStatus & " WHERE OrderID = " & CStr(lngOrderID)
		
		With cnnUpdate
			.Open(strUpdateConn)
			If Err.Number <> 0 Then
				'Connection failed
				UpdateOrderStatus = -1
				Exit Function
			End If
			.BeginTrans()
			.Execute(strSQLOrder, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
			If Err.Number <> 0 Or CInt(lngReccnt) = 0 Then
				'Order update failed
				UpdateOrderStatus = -2
				.RollbackTrans()
				.Close()
				Exit Function
			End If
			.Execute(strSQLItems, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
			If Err.Number <> 0 Or CInt(lngReccnt) = 0 Then
				'Line items update failed
				UpdateOrderStatus = -3
				.RollbackTrans()
				.Close()
			Else
				.CommitTrans()
				'Order plus line items
				UpdateOrderStatus = CShort(lngReccnt) + 1
			End If
		End With
	End Function
	
	Public Function DeleteLineItem(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngOrderID As Integer, ByVal bytItemID As Byte) As Short
		
		'Delete one or all line items for an order
		
		Dim cnnDelete As New ADODB.Connection
		Dim strDeleteConn As String
		Dim strSQL As String
		Dim lngReccnt As Integer
		
		On Error Resume Next
		
		strDeleteConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
		
		strSQL = "UPDATE LineItems SET Deleted = 1 WHERE OrderID = " & CStr(lngOrderID)
		If bytItemID > 0 Then
			strSQL = strSQL & " AND ItemID = " & CStr(bytItemID)
		End If
		
		With cnnDelete
			.Open(strDeleteConn)
			If Err.Number <> 0 Then
				'Can't connect
				DeleteLineItem = -1
				Exit Function
			End If
			.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
			If Err.Number <> 0 Then
				'Can't execute
				DeleteLineItem = -2
			Else
				DeleteLineItem = CShort(lngReccnt)
			End If
			.Close()
		End With
    End Function
End Class